10  ' These values are constants and should not be changed by the user
80  '
90  '
100 ' Change these values to match your LCD module
110 '
120  _C_Lines = 0               ' update this to 1, 2 or 4
130  _C_LineLength = 0          ' update this to 8, 16, 20, 40 or whatever
135 ' 				' You shouldn't have to change the next 4 values
140  _C_L1_Start = 0		
150  _C_L2_Start = 64	
160  _C_L3_Start = 20	
170  _C_L4_Start = 84
200 '
210 DIM _Offset(4)
220 _Offset(1) = _C_L1_Start	' load all the offsets into an array
230 _Offset(2) = _C_L2_Start
240 _Offset(3) = _C_L3_Start
250 _Offset(4) = _C_L4_Start
260 '
270 DIM _Text$(4)
280 '
290 ' Change these values to change the initial display message
300 ' Note: if you have a 20 character display, put spaces on the end to fill
310 ' them out to 20 characters length, otherwise you get strange characters displayed.
320 ' If you have a 16 character display, trim the spaces off the end until they're 16 chars long.
330 '
340 _Text$(1) = "Hello  World I'm    "	' load initial display values for the screen
350 _Text$(2) = "a Maximite LCD      "
360 _Text$(3) = "communicating with a"	' if you have a 2 line display, there's no harm leaving these extra lines here
370 _Text$(4) = "4 line HD44780 LCD. "
380 '
390 '
400 _FullDisplay = 1                    '  Start by showing full descriptions of the options.
410 '
1000 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
1010 ' V2 LCD driver for standard 16 X 2 and 20 X 4 LCDs
1020 '               James Deakins July 2011, 
1030 ' based on the original 16 X 2 code by
1040 '               Geoff Graham, March 2011
1050 '
1060 '  For example:  futurlec.com      LCD16X2
1070 '               altronics.com.au   Z7001
1080 '               jaycar.com.au      QP5512
1090 '               eBay               HD44780 based 20x4, has 2004A on crt board
1100 '
1110 ' To use:
1120 '  - Set up your text messages and number of lines / characters for your LCD
1130 '	 - execute GOSUB 29000 to initialise display
1140 '   - execute GOSUB 11000 to display the Explorer menu
1150 '   - Expect to see very different results if you're comparing a 2 and 4 line LCD.
1160 '
1170 '   - Cycle between the settings and display menus, choosing an option
1180 '     and seeing what the result is
1190 ' 
1200 '   - Select H on the Settings menu to toggle descriptions with the options
1210 '
1220 ' Make sure you have the right pinouts (see below).  There's a new
1230 ' schematic on Geoff's site, but if you have the old one, USE THIS
1240 ' PINOUT INFORMATION INSTEAD OF THE PINOUTS ON THE SCHEMATIC!!
1250 ' **************************************************************
1260 ' Maximite pin 11 is RS, pin 12 is EN. R/W is grounded.
1270 ' >>>pins 13 to 16 are D4 to D7.<<< May be different to schematic!
1280 ' **************************************************************
1290 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
1300 '
10000 ' Main Code
10010 '
10020 GOSUB 10200               'Make sure user has supplied lines and columns
10030 GOSUB 29000		'Initialise the LCD
10040 GOSUB 11000		'Display the LCD Settings Menu
10050 END
10060 '
10070 ' End of Main Code
10080 '
10100 ' Subroutines
10110 ' -----------
10120 '
10200 ' Check if the program has values for Lines and Columns for the LCD screen
10210 '
10220 IF (_C_Lines = 0) OR (_C_LineLength = 0) THEN
10230    Print "Please edit this file and change lines 120 and 130,"
10240    Print "and replace the zero values with the number of lines"
10250    Print "and columns on your LCD display."
10260    Print "Press any key to close the program."
10270    X$ = Inkey$
10280    if X$ = "" THEN GOTO 10270
10290    END
10300 ENDIF
10310 RETURN
10990 '
11000 ' Display the menu
11010 '
11020 '
11030 CLS
11040 IF _FullDisplay = 0 then
11050    GOSUB 11300
11060 ELSE
11070    GOSUB 11600
11080 ENDIF
11090 '
11100 Print
11110 Print "Enter a number above, Q to Quit, or H to toggle the Help display"
11120 INPUT "Please enter your selection: ", Sel$  : Sel$ = UCASE$(Sel$)
11130 IF Sel$ = "Q" THEN
11140    RETURN
11150 ELSEIF Sel$ = "H" THEN
11160    _FullDisplay = NOT _FullDisplay  ' toggle the value
11165    GOTO 11000
11170 ENDIF
11180 '
11190 Sel = Val(Sel$)
11200 '
11210 IF Sel < 1 OR Sel > 12 then
11220   Print "Sorry, that isn't a valid choice."
11230   pause 3000
11240   goto 11000
11250 endif
11260 '
11280 on Sel GOSUB 12000, 12100, 12200, 12300,12400,12500,12600,12700,12800,12900,13000,13100
11290 GOTO 11000
11300 ' Short Display
11350 Print
11370 Print "[1]  Clear Display "
11390 Print "[2]  Return Home   "
11420 Print " 3   Entry Mode SET"
11440 Print " 4   Display ON/OFF Control "
11460 Print " 5   Cursor or Display Shift"
11480 Print " 6   Function Set          "
11500 Print " 7   Set CG RAM Address    "
11510 Print " 8   Set DD RAM Address    "
11520 Print " 9   Read 'Busy' flag and address "
11540 Print " 10  Write DATA to RAM     "
11550 Print " 11  Read DATA from RAM    "
11560 Print " 12  Display some data to see how it is affected by the settings"
11570 RETURN
11600 ' Long Display 
11610 Print "This menu lets you try all the LCD setup options."
11620 Print "Some activate immediately.  Some only show results when you display some text."
11630 Print "The ones that activate immediately are in []s, the others prompt for values."
11640 Print "Please enter the number next to the option you want to try."
11650 Print
11660 Print "[0]  Exit"
11670 Print "[1]  Clear Display  (Write '20H' (space) to DDRAM and set DDRAM address"
11680 Print "                      to '00H' from Address Counter)"
11690 Print "[2]  Return Home    (Sets DDRAM address to '00H' from Address Counter and"
11700 Print "                      return cursor to its original position if shifted."
11710 Print "                      DDRAM contents are not changed)"
11720 Print " 3   Entry Mode SET (Assign cursor moving direction and enable shifting of"
11730 Print "                      the entire display)"
11740 Print " 4   Display ON/OFF Control  (Set control bits for Display, Cursor and"
11750 Print "                               Blinking Cursor)"
11760 Print " 5   Cursor or Display Shift (Set cursor moving and display shift control bit"
11770 Print "                              and direction without changing DDRAM data)"
11780 Print " 6   Function Set   (Sets Interface Data Length (4 or 8 bits) number of display "
11790 Print "                     lines (1 or 2) and display font type (5x11 or 5x8 dots))"
11800 Print " 7   Set CG RAM Address (Sets Character Generator RAM addr in address counter)"
11810 Print " 8   Set DD RAM Address (Sets DD RAM address in address counter)"
11820 Print " 9   Read 'Busy' flag and address (The Busy flag tells you if the panel is still"
11830 Print "                          doing internal operations.  Also allows AC to be read)"
11840 Print " 10  Write DATA to RAM (Writes data into internal RAM (DDRAM / CGRAM)"
11850 Print " 11  Read DATA from RAM (Reads data from internal RAM (DDRAM / CGRAM)"
11860 Print " 12  Display some data to see how it is affected by the settings"
11870 RETURN
12000 ' 1 selected - Clear Display
12001 ' --------------------------
12002 '
12010 _LCD_byte = &B00000001 : GOSUB 30000
12090 RETURN

12100 ' 2 selected - Return Home
12101 ' ------------------------
12102 '
12110 _LCD_byte = &B00000010 : GOSUB 30000
12190 RETURN

12200 ' 3 Selected - Character Entry Mode
12201 ' ---------------------------------
12202 '
12210 Input "Assign Cursor Moving Direction (L=Left, R=Right) ", Answer$
12220 CurDir$ = UCASE$(Answer$)
12230 Input "Enable shifting of entire display (Y,N) ", Answer$
12240 DispShift$ = UCASE$(Answer$)
12250 _LCD_byte = &B00000100
12260 if CurDir$ = "L" then _LCD_byte = _LCD_byte OR &B00000010
12270 if DispShift$ = "Y" then _LCD_byte = _LCD_byte OR &B00000001
12280 GOSUB 30000
12290 RETURN

12300 ' 4 selected - Display ON/OFF Control
12301 ' -----------------------------------
12302 '
12305 Input "Set Display ON (Y,N) ";Answer$
12310 DispOn$ = UCASE$(Answer$)
12315 Input "Set Cursor ON (Y,N) "; Answer$
12320 CurOn$ = UCASE$(Answer$)
12325 Input "Set Cursor Blink ON (Y,N)"; Answer$
12330 CurBlinkOn$ = UCASE$(Answer$)
12335 _LCD_byte = &B00001000
12340 If DispOn$ = "Y" then _LCD_byte = _LCD_byte OR &B00000100
12345 If CurOn$ = "Y" then _LCD_byte = _LCD_byte OR &B00000010
12350 If CurBlinkOn$ = "Y" then _LCD_byte = _LCD_byte OR &B00000001
12380 GOSUB 30000
12390 RETURN

12400 ' 5 selected - Cursor or Display Shift
12401 ' ------------------------------------
12402 '
12410 Input "Set Cursor move or Display shift (C,D) "; Answer$
12420 CorD$ = UCASE$(Answer$)
12430 Input "Set Left shift or Right shift (L,R) "; Answer$
12440 LorR$ = UCASE$(Answer$)
12450 _LCD_byte = &B00010000
12460 If CorD$ = "D" then _LCD_byte = _LCD_byte OR &B00001000
12470 If LorR$ = "R" then _LCD_byte = _LCD_byte OR &B00000100
12480 GOSUB 30000
12490 RETURN

12500 ' 6 selected - Function Set
12501 ' -------------------------
12502 '
12505 Input "Set Data Length (how many bits) (4,8) ";DataLen$
12510 Input "Set Number of Display Lines [answer 2 for 4 line displays] (1,2) ";DispLines$
12515 Input "Set Display Font [B=Big=5x11, S=Small=5x8] (B,S) ";Answer$
12520 DispFont$ = UCASE$(Answer$)
12530 _LCD_byte = &B00100000
12540 If DataLen$ = "8" then _LCD_byte = _LCD_byte OR &B00010000
12550 If DispLines$ = "2" then _LCD_byte = _LCD_byte OR &B00010000
12560 If DispFont$ = "S" then _LCD_byte = _LCD_byte OR &B00000100
12580 GOSUB 30000
12590 RETURN

12600 ' 7 selected Set CGRAM Address
12601 ' ----------------------------
12602 '
12610 Input "Please enter the address for CGRAM (0 to 63) ": Addr
12620 _LCD_byte = &B01000000
12630 _LCD_byte = _LCD_byte OR Addr
12640 GOSUB 30000
12690 RETURN

12700 ' 8 selected
12701 ' ----------
12702 '
12710 Print "Lines and columns start at 1 (there is no Line 0 or Column 0)."
12710 Input "Please enter the line and column (Line, Col) "; _LCD_Line, _LCD_Col
12720 GOSUB 30200   ' GOTO the Line and Col
12790 RETURN

12800 ' 9 selected
12801 ' ----------
12802 '
12810 ? "Not implemented yet"
12880 pause 3000
12890 RETURN

12900 ' 10 selected
12901 ' -----------
12902 '
12910 ? "Not implemented yet"
12980 pause 3000
12990 RETURN

13000 ' 11 selected
13001 ' -----------
13002 '
13010 ? "Not implemented yet"
13080 pause 3000
13090 RETURN

13100 ' 12 selected
13101 ' -----------
13102 '
13110 CLS
13120 Print "Make sure that you have used Option 8 to set the DD RAM address"
13130 Print "to point to the line that you want the message scrolled on"
13140 Print
13150 Print " 1  Display the standard 1, 2 or 4 line greeting message"
13160 Print " 2  Display a 26 character message, and scroll across"
13170 Print " 3  Print a 'Z' character at the location you previously selected"
13180 Print " 4  Print a non-standard character at the loc'n you previously selected"
13190 Print " 5  Use custom code to scroll a long message on the line you prev selected"


15000 INPUT "Please enter your selection: ", Sel
15010 If Sel < 0 OR Sel > 5 then
15020   Print "Sorry, that isn't a valid choice."
15030   pause 3000
15040   goto 13100
15050 endif
15060 '
15070 on Sel GOSUB 20000, 20200, 20400, 20500, 20600
15080 RETURN





20000 ' Display the default messages for the lines (defined at beginning of the code)
20010 ' -----------------------------------------------------------------------------
20020 ' This relies on the correct number of lines for the LCD being entered into _C_Lines, and the
20030 ' correct number of characters per line being entered into _C_LineLength.
20040 '
20050 for _Line_out = 1 to _C_Lines
20060	_LCD_byte = 128 + _Offset(_Line_out) : GOSUB 30000	' select the output line on the LCD
20070	for _LCD = 1 to _C_LineLength
20080		_LCD_byte = ASC(MID$(_Text$(_Line_out), _LCD, 1))
20090		Pin(11) = 1 : GOSUB 30000			' send the character
20100	next _LCD
20110 next _Line_out
20120 '
20130 RETURN

20200 ' Display a 26 character message, and scroll across
20210 ' -------------------------------------------------
20220 '
20230 ' Load a 26 char message into Line 2 (noting that on a 16 / 20 character display, we only see the first 16 / 20 characters)
20240 ' ----------------------------------------------------------------------------------------------------
20250 TestMsg$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
20260 for _LCD = 1 to 26
20270 	_LCD_byte = ASC(MID$(TestMsg$, _LCD, 1))
20280	Pin(11) = 1 : GOSUB 30000				' Send the character
20290 next _LCD
20300 '
20310 ' the user will now see the first 16 / 20 characters of our test message displayed on the second line
20320 '
20330 Input "You should now see 16 or 20 characters, depending on your screen.  Scroll it (Y,N)", Answer$
20340 Answer$ = UCASE$(Answer$)
20350 If Answer$ = "Y" then
20360 	' Shift the message so the balance of the second line can be read
20370 	' --------------------------------------------------------------
20372
20374 	GOSUB 30200		' for variety, we use the LCD LOCATE subroutine
20376 	for _LCD = 1 to 40
20378  		_LCD_byte = &B00011000 : GOSUB 30000
20380   	pause 1000
20382 	next _LCD
20384 Endif
20386 '
20388 ' Note that this shifts both lines left, and you have to shift left 40 times to get back where you started from
20390 ' -------------------------------------------------------------------------------------------------------------
20392 ' Also notice how the text may change to different lines as the message is scrolled.
20394 '
20396 RETURN

20400 ' Print a single character (Z) at the selected location
20410 '------------------------------------------------------
20440 _LCD_byte = ASC("Z") : pin(11) = 1 : gosub 30000		' Write a character to show it works
20450 RETURN

20500 ' Print a non-standard character from the character set held on the LCD
20502 ' ---------------------------------------------------------------------
20504 Input "Please input the hex value of the non-standard character you want to print (ie &HF4) "; _HexVal$
20506 _HexVal$ = UCASE$(_HexVal$)
20508 X = -1: Y = -1
20510 if LEFT$(_HexVal$,2) = "&H" then
20512    X$ = MID$(_HexVal$,3,1)
20514    IF X$ >= "0" AND X$ <= "9" THEN
20516        X = VAL(X$)
20518    ELSEIF X$ >= "A" AND X$ <= "F" THEN
20520        X = ASC(X$) - 55
20522    ENDIF
20524    Y$ = RIGHT$(_HexVal$,1)
20526    IF Y$ >= "0" AND Y$ <= "9" THEN
20528        Y = VAL(Y$)
20530    ELSEIF Y$ >= "A" AND Y$ <= "F" THEN
20532        Y = ASC(Y$) - 55
20534    ENDIF
20536  ENDIF
20538 IF (X = -1) OR (Y=-1) THEN
20540    ? "Invalid format for a Hexadecimal number"
20542 ELSE
20544    _DecVal = X * 16 + Y
20546    _LCD_byte = _DecVal : pin(11) = 1: GOSUB 30000     ' print the non standard character
20548 ENDIF
20590 RETURN

20600 ' use custom code to scroll a message on a given line
20610 ' ---------------------------------------------------
20630 Line Input "Please type in a long message "; LongMessage$
20640 MsgLen = Len(LongMessage$)
20650 For Mask_Offset = 0 to MsgLen - _C_LineLength		' keep track of where we're starting the display window
20655   GOSUB 30200                                             ' GOTO the previously selected line and column
20660 	for _LCD = 1 to _C_LineLength
20670		_LCD_byte = ASC(MID$(LongMessage$, Mask_Offset + _LCD, 1))
20680		Pin(11) = 1 : GOSUB 30000
20690	next _LCD
20700   if Mask_offset = 0 then pause 2000 else pause 800	' so screen has time to refresh, and user can read it
20710 next Mask_Offset
20720 RETURN


29000 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
29010 ' Initialise the LCD
29020 '
29030 FOR i = 11 TO 16 : SETPIN i, 9 : NEXT i	   ' set the pins to Open collector digital output to 5V
29040 _LCD_byte = &B0011 : GOSUB 30100             ' reset
29050 _LCD_byte = &B0011 : GOSUB 30100             ' reset
29060 _LCD_byte = &B0011 : GOSUB 30100             ' reset
29070 _LCD_byte = &B0010 : GOSUB 30100             ' 4 bit mode
29080 _LCD_byte = &B00101100 : GOSUB 30000         ' 4 bit, 2 lines (or 4 lines)
29090 _LCD_byte = &B00001100 : GOSUB 30000         ' display on, no cursor
29100 _LCD_byte = &B00000110 : GOSUB 30000         ' increment on write
29110 _LCD_byte = &B00000001 : GOSUB 30000         ' clear display
29120 pause 2
29130 RETURN
30000 ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
30010 ' Send a byte to the LCD
30020 ' the data to be sent is in _LCD_byte
30030 '
30040 PIN(13) = _LCD_byte AND &B00010000      ' output the 1st 4 bits
30050 PIN(14) = _LCD_byte AND &B00100000
30060 PIN(15) = _LCD_byte AND &B01000000
30070 PIN(16) = _LCD_byte AND &B10000000
30080 PIN(12) = 1 : PIN(12) = 0               ' tell lcd to accept data
30100 ' Entry point to send just 4 bits to the LCD
30110 PIN(13) = _LCD_byte AND &B00000001      ' output the 2nd 4 bits
30120 PIN(14) = _LCD_byte AND &B00000010
30130 PIN(15) = _LCD_byte AND &B00000100
30140 PIN(16) = _LCD_byte AND &B00001000
30150 PIN(12) = 1 : PIN(12) = 0 : PIN(11) = 0 ' tell lcd to accept data
30160 RETURN
30170 '
30200 ' Cursor LOCATE code
30210 '
30220 ' Move cursor to a location on the LCD screen
30240 ' The line is sent in _LCD_Line, the column is sent in _LCD_Col
30250 _Start = _Offset(_LCD_Line) + _LCD_Col -1
30270 _LCD_byte = 128 + _Start : GOSUB 30000	' move to the requested location
30280 RETURN
